<template>
    <div class="order-set-tariff">
      <ObForm
        :form-model="formModel"
        :form-data="formData"
        ok-text="Назначить"
        data-qa="SetTarifModal"
        @submit="onSubmitHandler"
        @cancel="$emit('cancel')"
      >
        <div
          v-if="doer"
          class="row"
        >
          <div class="col-xs-6">
            <ObInput
              label="Исполнитель"
              :value="doer.title"
              :readonly="true"
            />
          </div>
          <div class="col-xs-6">
            <ObInput
              label="ИНН"
              :value="doer.executorInn"
              :readonly="true"
            />
          </div>
        </div>
        <p>Вы выбрали исполнителя вручную. {{ order.species === 'AUTO' ? 'Аукцион, который был автоматически назначен системой на ваш заказ, будет продолжен.' : ''}}</p>

        <div class="info-block">
          <i class="icon alert" />
          <span>
            С контрагентом нет договора, укажите тариф вручную
            <br>
            <template v-if="!isVatPayer">НДС не облагается</template>
          </span>
        </div>

        <div
          v-if="isNds"
          class="nds-block"
        >
          <ObRadio
            :model-value="formData.assignedTariff && formData.assignedTariff.vatRate"
            label="НДС 20%"
            :value-input="20"
            class="mb10"
            data-qa="twentyNds"
            :readonly="!isManualInputNds"
            @change="onChangeNds"
          />
          <ObRadio
            :model-value="formData.assignedTariff && formData.assignedTariff.vatRate"
            label="НДС 0%"
            :value-input="0"
            class="mb20"
            data-qa="zeroNds"
            :readonly="!isManualInputNds"
            @change="onChangeNds"
          />
        </div>

        <ObCheckbox
          v-if="isVatPayer && (formData.assignedTariff && formData.assignedTariff.vatRate)"
          v-model="formData.isVatIncluded"
          label="Тарифы указываются с учетом НДС"
          data-qa="isVatInclude"
          class="mb15"
          @change="onChangeIsVatIncluded"
        />
        <div class="row row-inputs">
          <div class="col-xs-6">
            <ObInput
              :value="formData.tripTariff"
              :label="isVatPayer ? 'Тариф' : 'Тариф, НДС не облагается'"
              type="money:2"
              placeholder="Введите тариф"
              sub-title="₽"
              @input="onInputTariff"
            />
          </div>
          <div
            v-if="isVatPayer && (formData.assignedTariff && formData.assignedTariff.vatRate)"
            class="col-xs-6"
          >
            <ObInput
              :value="currentVatValue"
              type="money:2"
              :label="formData.isVatIncluded ? 'В том числе НДС' : 'Сумма НДС'"
              :readonly=true
            />
          </div>
        </div>
        <div class="title">Бумажные документы, связанные с событием</div>
        <ObUploader
          ref="uploader"
          data-qa="uploader"
          multiple
          :upload-method="uploadMethod"
          @change="onUploadHandler"
        />
      </ObForm>
    </div>
</template>

<script>
import { mapGetters } from 'vuex'
import api from '@/api'
import ObForm from 'common-components/src/obComponents/obForm'
import ObInput from 'common-components/src/obComponents/obInput'
import ObRadio from 'common-components/src/obComponents/obRadio'
import ObUploader from 'common-components/src/obComponents/obUploader'
import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import { required } from 'vuelidate/lib/validators'
import debounce from "debounce"

export default {
  name: 'SetTariffModal',
  mixins: [
    FormValidationMixin
  ],
  components: {
    ObForm,
    ObInput,
    ObUploader,
    ObCheckbox,
    ObRadio
  },
  props: {
    order: {
      type: Object,
      required: true
    },
    doer: {
      type: Object,
      default: () => {}
    }
  },
  data () {
    return {
      isLoading: false,
      isManualInputNds: false
    }
  },
  computed: {
    ...mapGetters({
      firstOrder: 'order/order'
    }),
    formModel () {
      let _self = this

      return {
        uuid: {
          value: () => _self.doer?.uuid
        },
        fileUuids: {
          value: ''
        },
        tripTariff: {
          value: '',
          validator: {
            required
          }
        },
        suborderSpecies: {
          value: () => _self.order.suborderSpecies,
          validator: {
            required
          }
        },
        isVatIncluded: {
          value: () => Boolean(_self.doer?.isVatInclude
          )
        },
        vat: {
          value: () => 20
        },
        assignedTariff: {
          value: () => {
            return {
              vatType: 'NO_VAT',
              vatRate: 0,
              vatPrice: 0
            }
          }
        }
      }
    },
    isNds () {
      return Boolean(this.isVatPayer)
    },
    isVatPayer () {
      return Boolean(this.doer?.isVatPayer)
    },
    isVatCharged () {
      return this.order.service?.isVatCharged || this.order.service?.isVatCharged === undefined
    },
    isInternational () {
      return ['FOREIGN', 'CROSSBOARDING'].includes(this.transboundary)
    },
    transboundary () {
      return this.order.suborderSpecies?.transboundary
    },
    routeCategory () {
      return this.order.suborderSpecies?.routeCategory
    },
    currentVatValue () {
      if (!this.isVatPayer) {
        return 0
      }
      return this.formData.assignedTariff?.vatPrice || 0
    },
    uploadMethod () {
      return api.files.postFile
    }
  },
  watch: {
    'formData.fileUuids' (value) {
      if (!value) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    },
  },
  methods: {
    async onUploadHandler (data) {
      if (!data || !data.length) {
        this.formData.fileUuids = null
        return
      }

      this.formData.fileUuids = data.map(item => item.uuid)
    },
    async onSubmitHandler (data) {
      data.tripTariff = data.assignedTariff.vatRate ? data.assignedTariff.priceWithVat : data.assignedTariff.priceWithoutVat

      try {
        this.$emit('on-submitted', data)
      } catch (e) {
        console.log(e)
      }
    },
    onChangeNds (value) {
      if (value) {
        this.formData.assignedTariff.vatRate = 20
        this.formData.assignedTariff.vatType = 'TWENTY'
        this.formData.isVatIncluded = true
      } else {
        this.formData.assignedTariff.vatRate = 0
        this.formData.assignedTariff.vatType = 'ZERO'
        this.formData.isVatIncluded = false
      }

      this.calcTariff(this.formData.tripTariff)
    },
    onChangeIsVatIncluded () {
      this.$nextTick(() => {
        this.calcTariff(this.formData.tripTariff)
      })
    },
    onInputTariff: debounce(async function(value) {
      this.formData.tripTariff = value
      await this.calcTariff(value)
    }, 500),
    async calcTariff (value) {
      if (this.formData.assignedTariff?.vatRate) {
        const postData = {
          vatRate: this.formData.assignedTariff.vatRate,
          quantity: 1
        }

        if (this.formData.assignedTariff.vatRate && this.formData.isVatIncluded) {
          postData.priceWithVat = value
        } else {
          postData.priceWithoutVat = value
        }
        let { totalWithoutVat, totalWithVat, totalVat } = await api.orderProcess.vatCalculation({ list: [postData] })

        this.formData.assignedTariff.priceWithoutVat = totalWithoutVat
        this.formData.assignedTariff.priceWithVat = totalWithVat
        this.formData.assignedTariff.vatPrice = totalVat
      } else {
        if (!this.formData.assignedTariff) {
          this.formData.assignedTariff = {}
        }
        this.formData.assignedTariff.priceWithoutVat = value
        this.formData.assignedTariff.priceWithVat = value
        this.formData.assignedTariff.vatPrice = 0
      }
    },
    async afterInitForm () {
      const { isMultimodal } = await api.orderProcess.isMultimodalOrder({ uuid: this.firstOrder.uuid })
      if (!this.isVatPayer || !this.isVatCharged) {
        this.formData.assignedTariff.vatType = 'NO_VAT'
        this.formData.assignedTariff.vatRate = 0
      } else {
        if (this.order.suborderSpecies?.species === 'order') {
          if (['URBAN', 'INTERURBAN'].includes(this.routeCategory) && this.transboundary === 'DOMESTIC') {
            this.isManualInputNds = false
            this.formData.assignedTariff.vatType = 'TWENTY'
            this.formData.assignedTariff.vatRate = 20
          }
          if (['INTERNATIONAL'].includes(this.routeCategory)) {
            if (isMultimodal) {
              this.isManualInputNds = true
              this.formData.assignedTariff.vatType = 'TWENTY'
              this.formData.assignedTariff.vatRate = 20
            } else {
              this.isManualInputNds = false
              this.formData.assignedTariff.vatType = 'ZERO'
              this.formData.assignedTariff.vatRate = 0
            }
          }
        } else if (['legOrderService', 'logchainService', 'shipmentPointService', 'shipmentPointOrderService'].includes(this.order.suborderSpecies?.species)) {
          if (this.transboundary === 'DOMESTIC') {
            if (['URBAN', 'INTERURBAN'].includes(this.routeCategory)) {
              this.isManualInputNds = false
              this.formData.assignedTariff.vatType = 'TWENTY'
              this.formData.assignedTariff.vatRate = 20
            }
            if (['INTERNATIONAL'].includes(this.routeCategory)) {
              this.isManualInputNds = false
              this.formData.assignedTariff.vatType = 'ZERO'
              this.formData.assignedTariff.vatRate = 0
            }
          } else if (['FOREIGN', 'CROSSBOARDING'].includes(this.transboundary)) {
            if (['INTERNATIONAL'].includes(this.routeCategory)) {
              this.isManualInputNds = true
              this.formData.assignedTariff.vatType = 'TWENTY'
              this.formData.assignedTariff.vatRate = 20
            }
          }
        } else {
          this.formData.assignedTariff.vatType = 'NO_VAT'
          this.formData.assignedTariff.vatRate = 0
        }
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .order-set-tariff {
    .row {
      margin-top: 10px!important;
      margin-bottom: 20px!important;
    }
    &::v-deep {
      .ob-input-wrap {
        margin-bottom: 10px;
      }
      .ob-radio-container {
        margin-bottom: 8px;
        margin-left: 4px;
      }
    }
    .title {
      margin-top: 30px;
      margin-bottom: 15px;
      @include font-mixin(16px, 24px, 600, $color-text-base , 0.4px);
    }
    .info-block {
      height: 64px;
      margin-top: 30px;
      margin-bottom: 30px;
      display: flex;
      align-items: center;
      padding: 0 20px;
      background-color: rgba(0, 243, 198, 0.1);
      .icon {
        margin-right: 20px;
        font-size: 24px;
        color: $Green-700;
      }
      span {
        @include font-mixin(14px, 20px, 400);
      }
    }
    .mb20 {
      margin-bottom: 20px!important;
    }
    .mb15 {
      margin-bottom: 15px!important;
    }
  }
</style>
